/* Network-Integrated Multimedia Middleware (NMM)
 * http://www.motama.com/nmm.html
 *
 * Copyright (C) 2006-2007
 * Motama GmbH, Saarbruecken, Germany
 * http://www.motama.com
 *
 * This file is part of NMM. 
 * 
 * NMM is free software; you can redistribute it and/or modify it    
 * under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; only version 2 of the License.      
 * 
 * NMM is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY 
 * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public 
 * License for more details.  
 * 
 * You should have received a copy of the GNU General Public License 
 * along with NMM; if not, write to the Free Software Foundation,    
 * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
 *
 */


module NMM {
  /**
   * Interface for controlling EPG-Plugins
   */
  interface ITVGuidePlugin {

    enum State{CONSTRUCTED = 1, INITIALIZED = 2, STARTED = 16 };

    /**
     * returns the name of the plugin
     */
    string getName();

    /**
     * Starts an update
     */
    Result start();
    
    /**
     * stops the update
     */
    Result stop();

    /**
     * initializes the plugin
     */
    Result init();
    /**
     * deinitializes the plugin
     */
    Result deinit();

    /**
     * get the current State of the plugin
     *@return plugin-state
     */
    ITVGuidePlugin::State getState();

    /**
     * set the priority of an TVGuide-plugin
     */
    void setPriority(in nmm_uint32 priority);

    /**
     * get the priority of an TVGuide-plugin
     */
    nmm_uint32 getPriority();

    /**
     * enables a TVGuide-Plugin. Indicates, that it should be startet by the TVGuide
     */
    Result enable();
    
    /**
     * disables a TVGuide-plugin. This plugin will not be startetd by TVGuide
     */
    Result disable();

    /**
     * returns, if the TVGuide-plugin is enabled
     */
    nmm_bool getEnabled();
  };
}
